Attribute VB_Name = "modMain"
Option Explicit

Private Declare Function SetWindowRgn Lib "user32" (ByVal hWnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Private Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Private Const RGN_OR As Long = 2

Public Sub SkinForm(ByRef Skin As Object)
Dim lngRegion   As Long
    If TypeOf Skin Is PictureBox Then
        lngRegion = MakeRegion(Skin)
        SetRegion Skin.Parent.hWnd, lngRegion
    Else
        Err.Raise 13
    End If
End Sub

Private Function SetRegion(ByVal plnghWnd As Long, ByVal plngWindowRegion As Long)
    SetWindowRgn plnghWnd, plngWindowRegion, True
End Function

Private Function MakeRegion(ByRef ppicSkin As PictureBox) As Long
Dim lngX                As Long
Dim lngY                As Long
Dim lngStartLineX       As Long
Dim lngFullRegion       As Long
Dim lngLineRegion       As Long
Dim lngTransparentColor As Long
Dim blnInFirstRegion    As Boolean
Dim blnInLine           As Boolean
Dim lnghDC              As Long
Dim lngWidth            As Long
Dim lngHeight           As Long
    lnghDC = ppicSkin.hDC
    lngWidth = ppicSkin.ScaleWidth
    lngHeight = ppicSkin.ScaleHeight
    blnInFirstRegion = True
    blnInLine = False
    lngX = 0
    lngY = 0
    lngStartLineX = 0
    lngTransparentColor = GetPixel(lnghDC, 0, 0)
    For lngY = 0 To lngHeight - 1
        For lngX = 0 To lngWidth - 1
            If (GetPixel(lnghDC, lngX, lngY) = lngTransparentColor) Or (lngX = lngWidth) Then
                If blnInLine Then
                    blnInLine = False
                    lngLineRegion = CreateRectRgn(lngStartLineX, lngY, lngX, lngY + 1)
                    If blnInFirstRegion Then
                        lngFullRegion = lngLineRegion
                        blnInFirstRegion = False
                    Else
                        CombineRgn lngFullRegion, lngFullRegion, lngLineRegion, RGN_OR
                        DeleteObject lngLineRegion
                    End If
                End If
            Else
                If Not blnInLine Then
                    blnInLine = True
                    lngStartLineX = lngX
                End If
            End If
        Next lngX
    Next lngY
    MakeRegion = lngFullRegion
End Function
